(***********************************************************************)
(*                                                                     *)
(*                        Call/cc for ocamlc                           *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 2005 Institut National de Recherche en Informatique et   *)
(*  en Automatique.  All rights reserved.  This file is distributed    *)
(*  under the terms of the GNU Library General Public License, with    *)
(*  the special exception on linking described in file LICENSE.        *)
(*                                                                     *)
(***********************************************************************)

(* $Id: callcc.ml,v 1.2 2005/10/05 08:16:49 xleroy Exp $ *)

type 'a cont

external duplicate_stack : unit -> 'a cont = "duplicate_stack"
external reinstall_stack : 'a cont * 'a -> 'b = "reinstall_stack"

let callcc_aux next = next (duplicate_stack())

let callcc next =
  let res = callcc_aux next in res
  (* Defeat tail-call optimization. We need to make sure that a return frame
     is pushed on the stack, containing in particular the extra_args count
     for the invocation of callcc (which may be applied to more than
     one argument). *)

let throw_aux cont_arg = reinstall_stack cont_arg

let throw cont arg = throw_aux (cont, arg)

